

#ifndef _MY_GRAPHICAL_LCD_H
	#define	_MY_GRAPHICAL_LCD_H
	#include "my_graphical_lcd.h"
#endif

#ifndef _LPC2138_H
	#define _LPC2138_H
	#include <LPC213X.H>	
#endif

//Connection Diagram
#define GLCD_CS1 0
#define GLCD_CS2 1
#define GLCD_RS 2 
#define GLCD_RW 3
#define GLCD_EN 4
#define GLCD_RST 5 


void shift(unsigned char x)
{
	unsigned char i;
	for(i=0;i<8;i++)
	{
		if( x & (0x01<<i))
		{
			IOSET0 |= 1<<(i+6);
		}
		else
		{
			IOCLR0 |= 1<<(i+6);		
		}
	}
}

void glcd0108_write(unsigned char c)
{
	shift(c);
	GLCD_PULSE();
}
void delay_small()
{
	unsigned char counter;
	for(counter=0;counter<255;counter++);
}
void GLCD_PULSE()
{
	IOSET0|=1<<GLCD_EN;
	delay_small();
	IOCLR0|=1<<GLCD_EN;
}

void CHIP_LEFT()
{
	IOSET0|=1<<GLCD_CS1;
	delay_small();
	IOCLR0|=1<<GLCD_CS2;
}
void CHIP_RIGHT()
{
	IOSET0|=1<<GLCD_CS2;
	delay_small();
	IOCLR0|=1<<GLCD_CS1;
}

void glcd0108_init(void)
{	
	IOSET0|=1<<GLCD_RST;
	IOSET0|=1<<GLCD_CS1;
	IOSET0|=1<<GLCD_CS2;
	glcd0108_write(0x3F);			//display on/off
	
}


void glcd0108_gotox(unsigned char c)
{
	IOCLR0|=1<<GLCD_RS;
	glcd0108_write(c+0xB8);
	IOSET0|=1<<GLCD_RS;
}

void glcd0108_gotoy(unsigned char c)
{
	IOCLR0|=1<<GLCD_RS;
	glcd0108_write(c+0x40);
	IOSET0|=1<<GLCD_RS;
}

void glcd0108_gotoz(unsigned char c)
{
	IOCLR0|=1<<GLCD_RS;
	glcd0108_write(c+0xC0);
	IOSET0|=1<<GLCD_RS;
}

void glcd0108_clear(void)
{
	char i,j;
	IOCLR0|=1<<GLCD_CS1;
	IOCLR0|=1<<GLCD_CS2;
	glcd0108_gotoy(0);
	glcd0108_gotoz(0);
	for(i=0;i<8;i++)
	{
		glcd0108_gotox(i);
		glcd0108_gotoy(0);
		glcd0108_gotoz(0);
		for(j=0;j<=63;j++)
		{
			delay_small();
			glcd0108_write(0x00);
		}
	}
}


void glcd0108_image(const char *image)
{
	unsigned int i,j;
		for(i=0;i<8;i++)
		{
			CHIP_LEFT();
			glcd0108_gotox(i);
			glcd0108_gotoy(0);
			glcd0108_gotoz(0);
			for(j=0;j<=63;j++)
			{			
				glcd0108_write((image[128*i+j]));
			}
			CHIP_RIGHT();
			glcd0108_gotox(i);
			glcd0108_gotoy(0);
			glcd0108_gotoz(0);
			for(j=0;j<=63;j++)
			{
				glcd0108_write((image[128*i+j+64]));
			}		
		}
}